import bpy
from mathutils import Vector


def median_point_object():
    sOb = bpy.context.selected_objects
    
    object_co = [obj.matrix_world.translation for obj in sOb]
    l = sum(object_co, Vector()) / len(sOb)
  
    return l


def cursor_point():
    cursor = bpy.context.scene.cursor
    l = cursor.location
    #l = cursor.matrix.decompose()[0]
    return l


def bb_point_ob():
    sOb = bpy.context.selected_objects

    x = (max([o.matrix_world.translation.x for o in sOb]) + min([o.matrix_world.translation.x for o in sOb])) / 2
    y = (max([o.matrix_world.translation.y for o in sOb]) + min([o.matrix_world.translation.y for o in sOb])) / 2
    z = (max([o.matrix_world.translation.z for o in sOb]) + min([o.matrix_world.translation.z for o in sOb])) / 2
    l = Vector((x, y, z))    
    
    return l