import bpy
from bpy.types import Operator


class GP_OT_qsnap(Operator):
    bl_idname = 'gp.snap'
    bl_label = 'Q-Snap'
    bl_description = ' '
    bl_options = {'REGISTER', 'UNDO', 'INTERNAL'}


    """ @classmethod
    def poll(cls, context):
        return context.mode == 'EDIT_MESH' """


    """ def __init__(self):
        self.vert = []
        self.active_element = None
        self.store_snap_mode = {}
        self.store_use_snap = False
        self.store_use_snap_self = False
        self.store_automerge = False """


    def modal(self, context, event):
        if event.type in {'RIGHTMOUSE', 'ESC'}:
            return {'CANCELLED'}

        if event.value == 'RELEASE' and event.type in {'LEFTMOUSE', 'RIGHTMOUSE'}:
            self.exit(context)

        st = context.scene.tool_settings.snap_target
        if event.type == 'WHEELUPMOUSE':
            if st == 'CLOSEST':
                context.scene.tool_settings.snap_target = 'ACTIVE'
            elif st == 'CENTER':
                context.scene.tool_settings.snap_target = 'CLOSEST'
            elif st == 'MEDIAN':
                context.scene.tool_settings.snap_target = 'CENTER'
            elif st == 'ACTIVE':
                context.scene.tool_settings.snap_target = 'MEDIAN'
                
            print( context.scene.tool_settings.snap_target )

        if event.type == 'WHEELDOWNMOUSE':
            if st == 'CLOSEST':
                context.scene.tool_settings.snap_target = 'CENTER'
            elif st == 'CENTER':
                context.scene.tool_settings.snap_target = 'MEDIAN'
            elif st == 'MEDIAN':
                context.scene.tool_settings.snap_target = 'ACTIVE'
            elif st == 'ACTIVE':
                context.scene.tool_settings.snap_target = 'CLOSEST'

            print( context.scene.tool_settings.snap_target )
      


       
 
        return {'INTERFACE'}
        

    def invoke(self, context, event):
        
        
        context.window_manager.modal_handler_add(self)
        return {'RUNNING_MODAL'}  


    def exit(self, context):
        return {'FINISHED'}


classes = [
    GP_OT_qsnap,
    ]


def register():
    for cls in classes:
        bpy.utils.register_class(cls)


def unregister():
    for cls in classes:
        bpy.utils.unregister_class(cls) 