import bpy
from mathutils import Matrix, Vector



REFRESH_MAT = False                             # --- важная опция для обновления матрицы 
LOCATION = Vector((0.0, 0.0, 0.0))
VALUE = [None, None]                            # --- значение для отображения в ui [value, position]
MOUSE_POSITION = [0, 0]                         # --- глобальное запоминание позиции мыши
CONTEXT_MODE = {'OBJECT', 'EDIT_MESH', 'EDIT_CURVE'} # --- общие режимы в каких работает гизмо про

TRANSPOSE_LOC = Vector((0.0, 0.0, 0.0))
TRANSPOSE_NORM = Vector((0.0, 0.0, 1.0))

LAST_LOC = Vector((0.0, 0.0, 0.0))

# --- QW / QM
QW_STORE_POS = Vector()                         # --- запоминание последней позиции, в основном для вызова из оператора
QW_USED_OP = False                              # --- проверка использовался ли оператор (keymaps)
QW_FIRST_CALL = False                           # --- для отслеживания первого запуска, после выключеннного PIN QW
QW_MENU = False
QW_SHOW_BAR = False
QW_ALIGN_STORE = 'CIRCLE'

# --- Pro Cursor
PCO_STORE_TPP = 'ACTIVE_ELEMENT'
PCO_STORE_TOS = 'GLOBAL'
PCO_MATRIX = Matrix()                           # --- марица PC
PCO_ALIGN = False                               # --- для выравнивания ориентации
PCO_USE_POS = True                              # --- определить позицию
PCO_USE_ORIENT = True                           # --- определить ориентацию
PCO_NORMAL_STORE = Vector()                     # --- запомнить прошлую нормаль TODO
PCO_MID_POINT = Vector()                        # --- для отступа PC TODO


# --- Switch Gizmo
TYPE_GIZMO = (True, True, True)
TYPE_LUNA = (True, True, True)